GraphicsMagick

- Home
- Project
- Download
- Install
- Source
- News
- Bugs
- Utilities
- Programming
- Reference

# pixel_cache

## Image pixel cache (working pixels).

Contents

- AccessCacheViewPixels
- AccessImmutableIndexes
- AccessMutableIndexes
- AccessMutablePixels
- AcquireCacheViewPixels
- AcquireCacheViewIndexes
- AcquireImagePixels
- AcquireOneCacheViewPixel
- AcquireOnePixel
- AcquireOnePixelByReference
- DestroyCacheInfo
- DestroyImagePixels
- GetCacheViewPixels
- GetCacheViewImage
- GetCacheViewIndexes
- GetImagePixels
- GetImagePixelsEx
- GetImageVirtualPixelMethod
- GetIndexes
- GetOnePixel
- GetPixels
- ModifyCache
- OpenCacheView
- ReferenceCache
- SetCacheViewPixels
- SetImagePixels
- SetImagePixelsEx
- SetImageVirtualPixelMethod
- SyncCacheViewPixels
- SyncImagePixels
- SyncImagePixelsEx

# AccessCacheViewPixels

## Synopsis

    PixelPacket *AccessCacheViewPixels( const ViewInfo *view );

## Description

Method AccessCacheViewPixels returns writeable pixels associated with the specified view.

The format of the AccessCacheViewPixels method is:

    PixelPacket *AccessCacheViewPixels( const ViewInfo *view );

A description of each parameter follows:

indexes:
  Method AccessCacheViewPixels returns the pixels associated with the specified view.
view:
  The address of a structure of type ViewInfo.

# AccessImmutableIndexes

## Synopsis

    const IndexPacket *AccessImmutableIndexes( const Image *image );

## Description

AccessImmutableIndexes() returns the colormap indexes associated with the last call to AcquireImagePixels(). NULL is returned if colormap indexes are not available.

The format of the AccessImmutableIndexes() method is:

    const IndexPacket *AccessImmutableIndexes( const Image *image );

A description of each parameter follows:

indexes:
  The indexes associated with the last call to AcquireImagePixels().
image:
  The image.

# AccessMutableIndexes

## Synopsis

    IndexPacket *AccessMutableIndexes( Image *image );

## Description

AccessMutableIndexes() returns the colormap indexes associated with the last call to SetImagePixels() or GetImagePixels(). NULL is returned if colormap indexes are not available.

The format of the AccessMutagleIndexes() method is:

    IndexPacket *AccessMutableIndexes( Image *image );

A description of each parameter follows:

indexes:
  The indexes associated with the last call to AcquireImagePixels().
image:
  The image.

# AccessMutablePixels

## Synopsis

    PixelPacket *AccessMutablePixels( Image image );

## Description

AccessMutablePixels() returns the pixels associated with the last call to SetImagePixels() or GetImagePixels(). This is useful in order to access an already selected region without passing the geometry of the region.

The format of the GetPixels() method is:

    PixelPacket *AccessMutablePixels( Image image );

A description of each parameter follows:

pixels:
  The pixels associated with the last call to SetImagePixels() or GetImagePixels().
image:
  The image.

# AcquireCacheViewPixels

## Synopsis

    const PixelPacket *AcquireCacheViewPixels( const ViewInfo *view, const long x,
                                               const long y, const unsigned long columns,
                                               const unsigned long rows,
                                               ExceptionInfo *exception );

## Description

Method AcquireCacheViewPixels gets pixels from the in-memory or disk pixel cache as defined by the geometry parameters for read-only access. A pointer to the pixels is returned if the pixels are transferred, otherwise NULL is returned.

The format of the AcquireCacheViewPixels method is:

    const PixelPacket *AcquireCacheViewPixels( const ViewInfo *view, const long x,
                                               const long y, const unsigned long columns,
                                               const unsigned long rows,
                                               ExceptionInfo *exception );

pixels:
  Method AcquireCacheViewPixels returns a null pointer if an error occurs, otherwise a pointer to the view pixels.
view:
  The address of a structure of type ViewInfo.
x,y,columns,rows:
  These values define the perimeter of a region of pixels.
exception:
  Return any errors or warnings in this structure.

# AcquireCacheViewIndexes

## Synopsis

    const IndexPacket *AcquireCacheViewIndexes( const ViewInfo *view );

## Description

Method AcquireCacheViewIndexes returns read-only indexes associated with the specified view.

The format of the AcquireCacheViewIndexes method is:

    const IndexPacket *AcquireCacheViewIndexes( const ViewInfo *view );

A description of each parameter follows:

indexes:
  Method AcquireCacheViewIndexes returns the indexes associated with the specified view.
view:
  The address of a structure of type ViewInfo.

# AcquireImagePixels

## Synopsis

    const PixelPacket *AcquireImagePixels( const Image *image, const long x, const long y,
                                           const unsigned long columns, const unsigned long rows,
                                           ExceptionInfo *exception );

## Description

AcquireImagePixels() obtains a pixel region for read-only access. If the region is successfully accessed, a pointer to it is returned, otherwise NULL is returned. The returned pointer may point to a temporary working copy of the pixels or it may point to the original pixels in memory. Performance is maximized if the selected area is part of one row, or one or more full rows, since then there is opportunity to access the pixels in-place (without a copy) if the image is in RAM, or in a memory-mapped file. The returned pointer should never be deallocated by the user.

Pixels accessed via the returned pointer represent a simple array of type PixelPacket. If the image storage class is PsudeoClass, call GetIndexes() after invoking GetImagePixels() to obtain the colormap indexes (of type IndexPacket) corresponding to the region.

If you plan to modify the pixels, use GetImagePixels() instead.

The format of the AcquireImagePixels() method is:

    const PixelPacket *AcquireImagePixels( const Image *image, const long x, const long y,
                                           const unsigned long columns, const unsigned long rows,
                                           ExceptionInfo *exception );

status:
  AcquireImagePixels() returns a pointer to the pixels if they are transferred, otherwise a NULL is returned.
image:
  The image.
x,y,columns,rows:
  These values define the perimeter of a region of pixels.
exception:
  Return any errors or warnings in this structure.

# AcquireOneCacheViewPixel

## Synopsis

    MagickPassFail AcquireOneCacheViewPixel( const ViewInfo *view, PixelPacket *pixel,
                                             const long x, const long y,
                                             ExceptionInfo *exception );

## Description

Method AcquireOneCacheViewPixel gets one pixel from the in-memory or disk pixel cache as defined by the geometry parameters for read-only access. The image background color is returned if there is an error retrieving the pixel.

The format of the AcquireOneCacheViewPixel method is:

    MagickPassFail AcquireOneCacheViewPixel( const ViewInfo *view, PixelPacket *pixel,
                                             const long x, const long y,
                                             ExceptionInfo *exception );

view:
  The address of a structure of type ViewInfo.
pixel:
  Pointer to PixelPacket to update.
x,y:
  Coordinate of pixel to retrieve
exception:
  Return any errors or warnings in this structure.

# AcquireOnePixel

## Synopsis

    PixelPacket AcquireOnePixel( const Image image, const long x, const long y,
                                  ExceptionInfo exception );

## Description

AcquireOnePixel() returns a single pixel at the specified (x,y) location. The image background color is returned if an error occurs. If errors are to be returned to the image, use GetOnePixel() instead. This function is convenient but performance will be poor if it is used too often.

The format of the AcquireOnePixel() method is:

    PixelPacket AcquireOnePixel( const Image image, const long x, const long y,
                                  ExceptionInfo exception );

pixels:
  AcquireOnePixel() returns a pixel at the specified (x,y) location.
image:
  The image.
x,y:
  These values define the location of the pixel to return.
exception:
  Return any errors or warnings in this structure.

# AcquireOnePixelByReference

## Synopsis

    MagickPassFail AcquireOnePixelByReference( const Image *image, PixelPacket *pixel,
                                               const long x, const long y,
                                               ExceptionInfo *exception );

## Description

AcquireOnePixelByReference() returns a single pixel at the specified (x,y) location. The image background color is returned if an error occurs. This function is convenient but performance will be poor if it is used too often.

The format of the AcquireOnePixelByReference() method is:

    MagickPassFail AcquireOnePixelByReference( const Image *image, PixelPacket *pixel,
                                               const long x, const long y,
                                               ExceptionInfo *exception );

pixels:
  AcquireOnePixel() returns a pixel at the specified (x,y) location.
image:
  The image.
pixel:
  A reference to the pixel to update.
x,y:
  These values define the location of the pixel to return.
exception:
  Return any errors or warnings in this structure.

# DestroyCacheInfo

## Synopsis

    void DestroyCacheInfo( Cache cache );

## Description

DestroyCacheInfo() deallocates memory associated with the pixel cache.

The format of the DestroyCacheInfo() method is:

    void DestroyCacheInfo( Cache cache );

A description of each parameter follows:

cache:
  Specifies a pointer to a Cache structure.

# DestroyImagePixels

## Synopsis

    void DestroyImagePixels( Image *image );

## Description

DestroyImagePixels() deallocates memory associated with the pixel cache.

The format of the DestroyImagePixels() method is:

    void DestroyImagePixels( Image *image );

A description of each parameter follows:

image:
  The image.

# GetCacheViewPixels

## Synopsis

    PixelPacket *GetCacheViewPixels( ViewInfo *view, const long x, const long y,
                                     const unsigned long columns, const unsigned long rows,
                                     ExceptionInfo *exception );

## Description

GetCacheViewPixels() gets writeable pixels from the in-memory or disk pixel cache as defined by the geometry parameters. A pointer to the pixels is returned if the pixels are transferred, otherwise a NULL is returned.

The format of the GetCacheViewPixels method is:

    PixelPacket *GetCacheViewPixels( ViewInfo *view, const long x, const long y,
                                     const unsigned long columns, const unsigned long rows,
                                     ExceptionInfo *exception );

pixels:
  Method GetCacheViewPixels returns a null pointer if an error occurs, otherwise a pointer to the view pixels.
view:
  The address of a structure of type ViewInfo.
x,y,columns,rows:
  These values define the perimeter of a region of pixels.
exception:
  Any errors are reported here.

# GetCacheViewImage

## Synopsis

    Image *GetCacheViewImage( const ViewInfo *view );

## Description

Method GetCacheViewImage returns the image which allocated the view.

The format of the GetCacheViewImage method is:

    Image *GetCacheViewImage( const ViewInfo *view );

A description of each parameter follows:

image:
  Method GetCacheViewImage returns the image which allocated the view.
view:
  The address of a structure of type ViewInfo.

# GetCacheViewIndexes

## Synopsis

    IndexPacket *GetCacheViewIndexes( const ViewInfo *view );

## Description

Method GetCacheViewIndexes returns writeable indexes associated with the specified view.

The format of the GetCacheViewIndexes method is:

    IndexPacket *GetCacheViewIndexes( const ViewInfo *view );

A description of each parameter follows:

indexes:
  Method GetCacheViewIndexes returns the indexes associated with the specified view.
view:
  The address of a structure of type ViewInfo.

# GetImagePixels

## Synopsis

    PixelPacket *GetImagePixels( Image *image, const long x, const long y,
                                 const unsigned long columns, const unsigned long rows );

## Description

GetImagePixels() obtains a pixel region for read/write access. If the region is successfully accessed, a pointer to a PixelPacket array representing the region is returned, otherwise NULL is returned.

The returned pointer may point to a temporary working copy of the pixels or it may point to the original pixels in memory. Performance is maximized if the selected area is part of one row, or one or more full rows, since then there is opportunity to access the pixels in-place (without a copy) if the image is in RAM, or in a memory-mapped file. The returned pointer should never be deallocated by the user.

Pixels accessed via the returned pointer represent a simple array of type PixelPacket. If the image storage class is PsudeoClass, call GetIndexes() after invoking GetImagePixels() to obtain the colormap indexes (of type IndexPacket) corresponding to the region. Once the PixelPacket (and/or IndexPacket) array has been updated, the changes must be saved back to the underlying image using SyncImagePixels() or they may be lost.

The format of the GetImagePixels() method is:

    PixelPacket *GetImagePixels( Image *image, const long x, const long y,
                                 const unsigned long columns, const unsigned long rows );

status:
  GetImagePixels() returns a pointer to the pixels if they are transferred, otherwise a NULL is returned.
image:
  The image.
x,y,columns,rows:
  These values define the perimeter of a region of pixels.

# GetImagePixelsEx

## Synopsis

    PixelPacket *GetImagePixelsEx( Image *image, const long x, const long y,
                                   const unsigned long columns, const unsigned long rows,
                                   ExceptionInfo *exception );

## Description

GetImagePixelsEx() obtains a pixel region for read/write access. It is similar to GetImagePixels() except that it reports any error information to a user provided exception structure.

The format of the GetImagePixelsEx() method is:

    PixelPacket *GetImagePixelsEx( Image *image, const long x, const long y,
                                   const unsigned long columns, const unsigned long rows,
                                   ExceptionInfo *exception );

status:
  GetImagePixelsEx() returns a pointer to the pixels if they are transferred, otherwise a NULL is returned.
image:
  The image.
x,y,columns,rows:
  These values define the perimeter of a region of pixels.
exception:
  Any error details are reported here.

# GetImageVirtualPixelMethod

## Synopsis

    VirtualPixelMethod GetImageVirtualPixelMethod( const Image *image );

## Description

GetImageVirtualPixelMethod() gets the "virtual pixels" method for the image. A virtual pixel is any pixel access that is outside the boundaries of the image cache.

The format of the GetImageVirtualPixelMethod() method is:

    VirtualPixelMethod GetImageVirtualPixelMethod( const Image *image );

A description of each parameter follows:

image:
  The image.

# GetIndexes

## Synopsis

    IndexPacket *GetIndexes( const Image *image );

## Description

GetIndexes() returns the colormap indexes associated with the last call to SetImagePixels() or GetImagePixels(). NULL is returned if colormap indexes are not available.

The format of the GetIndexes() method is:

    IndexPacket *GetIndexes( const Image *image );

A description of each parameter follows:

indexes:
  GetIndexes() returns the indexes associated with the last call to SetImagePixels() or GetImagePixels().
image:
  The image.

# GetOnePixel

## Synopsis

    PixelPacket GetOnePixel( const Image image, const long x, const long y );

## Description

GetOnePixel() returns a single pixel at the specified (x,y) location. The image background color is returned if an error occurs. This function is convenient but performance will be poor if it is used too often. GetOnePixel() is identical to AcquireOnePixel() except that exceptions are implicitly delivered to the image.

The format of the GetOnePixel() method is:

    PixelPacket GetOnePixel( const Image image, const long x, const long y );

A description of each parameter follows:

image:
  The image.
x,y:
  These values define the location of the pixel to return.

# GetPixels

## Synopsis

    PixelPacket *GetPixels( const Image image );

## Description

GetPixels() returns the pixels associated with the last call to SetImagePixels() or GetImagePixels(). This is useful in order to access an already selected region without passing the geometry of the region.

The format of the GetPixels() method is:

    PixelPacket *GetPixels( const Image image );

A description of each parameter follows:

pixels:
  GetPixels() returns the pixels associated with the last call to SetImagePixels() or GetImagePixels().
image:
  The image.

# ModifyCache

## Synopsis

    MagickPassFail ModifyCache( Image *image, ExceptionInfo *exception );

## Description

ModifyCache() ensures that there is only a single reference to the pixel cache to be modified, updating the provided cache pointer to point to a clone of the original pixel cache if necessary. This is used to implement copy on write.

The format of the ModifyCache method is:

    MagickPassFail ModifyCache( Image *image, ExceptionInfo *exception );

A description of each parameter follows:

image:
  The image.
exception:
  Errors are reported here.

# OpenCacheView

## Synopsis

    ViewInfo *OpenCacheView( Image *image );

## Description

OpenCacheView() opens a view into the pixel cache.

The format of the OpenCacheView method is:

    ViewInfo *OpenCacheView( Image *image );

A description of each parameter follows:

image:
  The image.

# ReferenceCache

## Synopsis

    Cache ReferenceCache( Cache cache_info );

## Description

ReferenceCache() increments the reference count associated with the pixel cache returning a pointer to the cache.

The format of the ReferenceCache method is:

    Cache ReferenceCache( Cache cache_info );

A description of each parameter follows:

cache_info:
  The cache_info.

# SetCacheViewPixels

## Synopsis

    PixelPacket *SetCacheViewPixels( const ViewInfo *view, const long x, const long y,
                                     const unsigned long columns, const unsigned long rows );

## Description

SetCacheViewPixels() gets pixels from the in-memory or disk pixel cache as defined by the geometry parameters. A pointer to the pixels is returned if the pixels are transferred, otherwise a NULL is returned.

The format of the SetCacheViewPixels method is:

    PixelPacket *SetCacheViewPixels( const ViewInfo *view, const long x, const long y,
                                     const unsigned long columns, const unsigned long rows );

view:
  The address of a structure of type ViewInfo.
x,y,columns,rows:
  These values define the perimeter of a region of pixels.
exception:
  Any errors are reported here.

# SetImagePixels

## Synopsis

    PixelPacket *SetImagePixels( Image *image, const long x, const long y,
                                 const unsigned long columns, const unsigned long rows );

## Description

SetImagePixels() initializes a pixel region for write-only access. If the region is successfully intialized a pointer to a PixelPacket array representing the region is returned, otherwise NULL is returned. The returned pointer may point to a temporary working buffer for the pixels or it may point to the final location of the pixels in memory.

Write-only access means that any existing pixel values corresponding to the region are ignored. This is useful while the initial image is being created from scratch, or if the existing pixel values are to be completely replaced without need to refer to their pre-existing values. The application is free to read and write the pixel buffer returned by SetImagePixels() any way it pleases. SetImagePixels() does not initialize the pixel array values. Initializing pixel array values is the application's responsibility.

Performance is maximized if the selected area is part of one row, or one or more full rows, since then there is opportunity to access the pixels in-place (without a copy) if the image is in RAM, or in a memory-mapped file. The returned pointer should never be deallocated by the user.

Pixels accessed via the returned pointer represent a simple array of type PixelPacket. If the image storage class is PsudeoClass, call GetIndexes() after invoking GetImagePixels() to obtain the colormap indexes (of type IndexPacket) corresponding to the region. Once the PixelPacket (and/or IndexPacket) array has been updated, the changes must be saved back to the underlying image using SyncCacheNexus() or they may be lost.

The format of the SetImagePixels() method is:

    PixelPacket *SetImagePixels( Image *image, const long x, const long y,
                                 const unsigned long columns, const unsigned long rows );

pixels:
  SetImagePixels returns a pointer to the pixels if they are transferred, otherwise a NULL is returned.
image:
  The image.
x,y,columns,rows:
  These values define the perimeter of a region of pixels.

# SetImagePixelsEx

## Synopsis

    PixelPacket *SetImagePixelsEx( Image *image, const long x, const long y,
                                   const unsigned long columns, const unsigned long rows,
                                   ExceptionInfo *exception );

## Description

SetImagePixelsEx() initializes a pixel region for write-only access. It is similar to SetImagePixels() except that any exception information is written to a user provided exception structure.

The format of the SetImagePixelsEx() method is:

    PixelPacket *SetImagePixelsEx( Image *image, const long x, const long y,
                                   const unsigned long columns, const unsigned long rows,
                                   ExceptionInfo *exception );

pixels:
  SetImagePixelsEx returns a pointer to the pixels if they are transferred, otherwise a NULL is returned.
image:
  The image.
x,y,columns,rows:
  These values define the perimeter of a region of pixels.
exception:
  Any error details are reported here.

# SetImageVirtualPixelMethod

## Synopsis

    SetImageVirtualPixelMethod( const Image *image, const VirtualPixelMethod method );

## Description

SetImageVirtualPixelMethod() sets the "virtual pixels" method for the image. A virtual pixel is any pixel access that is outside the boundaries of the image cache.

The format of the SetImageVirtualPixelMethod() method is:

    SetImageVirtualPixelMethod( const Image *image, const VirtualPixelMethod method );

image:
  The image.
type:
  choose from these access types:

EdgeVPType: the edge pixels of the image extend infinitely. Any pixel outside the image is assigned the same value as the pixel at the edge closest to it.

TileVPType: the image extends periodically or tiled. The pixels wrap around the edges of the image.

MirrorVPType: mirror the image at the boundaries.

ConstantVPType: every value outside the image is a constant as defines by the pixel parameter.

# SyncCacheViewPixels

## Synopsis

    MagickPassFail SyncCacheViewPixels( const ViewInfo *view, ExceptionInfo *exception );

## Description

SyncCacheViewPixels() saves the view pixels to the in-memory or disk cache. The method returns MagickPass if the pixel region is synced, otherwise MagickFail.

The format of the SyncCacheViewPixels method is:

    MagickPassFail SyncCacheViewPixels( const ViewInfo *view, ExceptionInfo *exception );

view:
  The address of a structure of type ViewInfo.
exception:
  Any errors are reported here.

# SyncImagePixels

## Synopsis

    MagickPassFail SyncImagePixels( Image *image );

## Description

SyncImagePixels() saves the image pixels to the in-memory or disk cache. The method returns MagickPass if the pixel region is synced, otherwise MagickFail.

The format of the SyncImagePixels() method is:

    MagickPassFail SyncImagePixels( Image *image );

A description of each parameter follows:

status:
  SyncImagePixels() returns MagickPass if the image pixels are transferred to the in-memory or disk cache otherwise MagickFail.
image:
  The image.

# SyncImagePixelsEx

## Synopsis

    MagickPassFail SyncImagePixelsEx( Image *image, ExceptionInfo *exception );

## Description

SyncImagePixelsEx() saves the image pixels to the in-memory or disk cache. The method returns MagickPass if the pixel region is synced, otherwise MagickFail.

The format of the SyncImagePixelsEx() method is:

    MagickPassFail SyncImagePixelsEx( Image *image, ExceptionInfo *exception );

A description of each parameter follows:

status:
  SyncImagePixelsEx() returns MagickPass if the image pixels are transferred to the in-memory or disk cache otherwise MagickFail.
image:
  The image.
exception:
  Any error details are reported here.